import { BehaviorSubject, Observable, Observer, Subject, Subscriber, Unsubscribable } from "rxjs";
import dotenv from 'dotenv';
import { AdapterProfile, AdaptorTransmissionRole, ConnectionAdaptorBase, ConnectionState, TransportMessage } from "../interface/connector.interface";
import { Bus, FisAppActor, FisMessage } from "../interface/transport.interface";

dotenv.config();
/* This transport manager will be instantiating the necessary transport to deal with tranmission and receiving from different receivers
So how?: */
export class ConnectionAdapter implements ConnectionAdaptorBase {
    connector: any;
    connectorProfile!: AdapterProfile;
    connectionStateBus!: BehaviorSubject<ConnectionState>;
    adaptorTransmissionRole!: AdaptorTransmissionRole;

    constructor(port?: number, url?: string) {
        if (!port && !url) console.error(`No role has assigned for transport service due to lack of information provided!`)
    }
    getInfo(): any {
        throw new Error("Method not implemented.");
    }
    subscribeConnectionState(): Observable<ConnectionState> {
        throw new Error("Method not implemented.");
    }
    publishConnectionState(): void {
        throw new Error("Method not implemented.");
    }
    connect(): void {
        throw new Error("Method not implemented.");
    }
    disconnect(): void {
        throw new Error("Method not implemented.");
    }
    getMessageBus(bus: Bus): Observable<any> {
        throw new Error("Method not implemented.");
    }    
    subscribeMessages(messageFilter: any): Observable<any> {
        throw new Error("Method not implemented.");
    }


}


